<template>
  <div>
    <el-form-item label="上传类型"  >
      <el-radio-group v-model="localUploadType">
        <el-radio :label="2" >线路一</el-radio>
        <el-radio :label="1" >线路二</el-radio>
<!--        <el-radio :label="3" >线路三</el-radio>-->
      </el-radio-group>
    </el-form-item>
    <el-form-item label="视频上传">
      <div class="upload_video" id="upload_video">
        <el-upload
          class="upload-demo"
          ref="upload"
          action="#"
          :http-request="uploadVideoToTxPcdn"
          accept=".mp4"
          :limit="1"
          :on-remove="handleRemove"
          :on-change="handleChange"
          :auto-upload="false"
          :key="uploadKey"
        >
          <el-button slot="trigger" size="small" type="primary">选取视频</el-button>
          <el-button style="margin-left: 10px;" size="small" type="success" @click="submitUpload">点击上传</el-button>
          <el-progress style="margin-top: 10px;" class="progress" :text-inside="true" :stroke-width="18" :percentage="progress" status="success"></el-progress>
          <div slot="tip" class="el-upload__tip">只能上传mp4文件，且不超过500M</div>
        </el-upload>
        <video v-if="videoUrl" ref="myvideo" :src="videoUrl" id="video" width="100%" height="300px" controls></video>
        <!-- <canvas id="mycanvas" style="display:none"></canvas> -->
        <div v-if="fileName">视频文件名: {{ fileName }}</div>
        <div v-if="fileKey">文件Key: {{ fileKey }}</div>
        <div v-if="fileSize">文件大小(MB): {{ (fileSize / (1024 * 1024)).toFixed(2) }} MB</div>
      </div>
    </el-form-item>
    <!-- <el-form-item label="视频封面">

    </el-form-item> -->
  </div>
</template>

<script>
import {getSignature, uploadHuaWeiObs, uploadHuaWeiVod} from "@/api/common";
import {getThumbnail} from "@/api/course/userVideo";
import TcVod from "vod-js-sdk-v6";
import { uploadObject } from "@/utils/cos.js";
import { uploadToOBS } from "@/utils/obs.js";

export default {
  props: {
    videoUrl: {
      type: String,
      default: "",
    },
    fileKey: {
      type: String,
      default: "",
    },
    fileSize: {
      type: Number,
      default: null,
    },
    fileName: {
      type: String,
      default: "",
    },
    line_1: {
      type: String,
      default: "",
    },
    line_2: {
      type: String,
      default: "",
    },
    line_3: {
      type: String,
      default: "",
    },
    thumbnail: {
      type: String,
      default: "",
    },
    uploadType: {
      type: Number,
      default: null,
    },
    type: {
      type: Number,
      default: null,
    },
    isPrivate: {
      type: Number,
      default: 0,
    },
  },
  data() {
    return {
      videoName:'',
      isHidden : false,
      localUploadType: this.uploadType,
      duration: 0,
      fileId: "",
      uploadTypeOptions: [
        { dictLabel: "线路一", dictValue: 2 }, //腾讯pcdn

        { dictLabel: "线路二", dictValue: 1 }, //电信
        // { dictLabel: "线路三", dictValue: 3 }, //华为云obs
        // { dictLabel: "华为云VOD", dictValue: 4 },
        // { dictLabel: "腾讯云VOD", dictValue: 5 },
      ],
      fileList: [],
      progress: 0,
      uploadLoading: false,
      uploadKey: 0,
      // thumbnail: '',
    };
  },
  watch: {
    localUploadType(newType) {
      this.$emit("update:uploadType", newType);
      this.$emit("change");
    },
    uploadType(newType) {
      this.localUploadType = newType;
    },
  },
  methods: {
    handleChange(file, fileList) {
      this.fileList = fileList;
      this.getVideoDuration(file.raw);

    },
    getVideoDuration(file) {
      const video = document.createElement("video");
      video.preload = "metadata";
      video.onloadedmetadata = () => {
        window.URL.revokeObjectURL(video.src);
        this.duration = parseInt(video.duration.toFixed(2));
        console.log("视频时长=========>",this.duration);
        this.$emit("video-duration", this.duration);
        console.log("文件大小=====>",file.size);
        this.$emit("update:fileSize", file.size);
      };
      video.src = URL.createObjectURL(file);
    },
    async submitUpload() {
      if (this.fileList.length < 1) {
        return this.$message.error("请先选取视频，再进行上传");
      }
      if (this.localUploadType == null) {
        return this.$message.error("请先选择上传类型，再进行上传");
      }
      this.getFirstThumbnail();
      if (this.localUploadType == 1 || this.localUploadType == 2) {
        // 腾讯云PCDN 上传逻辑
        this.uploadVideoToTxPcdn();
      } else if (this.localUploadType == 3) {
        this.uploadVideoToHwObs();
      }
      this.$emit("update:fileName", this.fileList[0].name);
    },
    async getFirstThumbnail(){
      const file = this.fileList[0].raw;
      getThumbnail(file).then(response => {
        console.log("获取到第一帧为封面======>",response.url)
        this.$emit("update:thumbnail", response.url);
      })
    },
    updateHwProgress(progress) {
      this.progress = progress;
    },
    updateTxProgress(progressData) {
      this.progress = Math.round(progressData.percent * 100);
    },
    async uploadVideoToTxPcdn() {
      try {
        const file = this.fileList[0].raw;
        // const type = 2;
        const data = await uploadObject(file, this.updateTxProgress,this.type);
        console.log("腾讯COS返回========>",data);
        console.log("isPrivate=======>",this.isPrivate)
        let line_1='' ;
        let line_2 ='';

        line_1 = `https://zzftcpv.ylrzcloud.com${data.urlPath}`;
        line_2 = `https://zzfctev.ylrzcloud.com${data.urlPath}`;


        let urlPathWithoutFirstSlash = data.urlPath.substring(1);
        this.$emit("update:fileKey", urlPathWithoutFirstSlash);

        console.log("文件key",urlPathWithoutFirstSlash);
        console.log("组装URL========>",line_1);
        this.$emit("update:videoUrl", line_1);
        this.$emit("update:line_1", line_1);
        this.$emit("update:line_2", line_2);
        this.$message.success("视频上传成功");
      } catch (error) {
        this.$message.error("上传失败");
      }
    },
    async uploadVideoToHwObs() {
      try {
        const file = this.fileList[0].raw;
        const data = await uploadToOBS(file, this.updateHwProgress,this.type);
        this.$emit("update:videoUrl", data);
        this.$emit("update:line_3", data);
        this.$message.success("视频上传成功");
      } catch (error) {
        this.$message.error("上传失败");
      }
    },
    handleRemove(file, fileList) {
      console.log(file, fileList.length);
    },
    resetUpload() {
      this.progress = 0;
      this.fileList = [];
      this.uploadKey++;
    },
  },
};
</script>
